VERSION 5.00
Begin VB.Form frmMDIChild 
   AutoRedraw      =   -1  'True
   Caption         =   "Collection Member"
   ClientHeight    =   2940
   ClientLeft      =   3000
   ClientTop       =   1425
   ClientWidth     =   4965
   Icon            =   "frmMDIChild.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   196
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   331
   Begin VB.CommandButton cmdRaiseClick 
      Caption         =   "Raise Click"
      Height          =   405
      Left            =   1875
      TabIndex        =   0
      Top             =   1230
      Width           =   1215
   End
End
Attribute VB_Name = "frmMDIChild"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to raise events from objects contained
  ' in a collection or array without creating circular references
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.


  ' module level variable to hold the value of our Key property
  Private m_sKey As String
  
  ' variable to hold the unreferenced pointer to the parent object
  Private m_lpCChildForms As Long

' key property
Public Property Get Key() As String
  Key = m_sKey
End Property
Public Property Let Key(ByVal sNewVal$)
  m_sKey = sNewVal
End Property

' write only property used to pass in the pointer to our collection object
' when this object is created and added to the collection
Friend Property Let CollectionPointer(ByVal nNewVal&)
  If m_lpCChildForms Then
    ' the pointer should only be set one time when this form is created
    ' so we raise an error if m_lpCChildForms already holds a value
    Err.Raise &H80000700, , "Pointer already initialized"
  Else
    m_lpCChildForms = nNewVal
  End If
End Property

' **************************************************
' pass the form events on to the collection object
Private Sub Form_Activate()
  CallEvent cf_ChildActivated
End Sub

Private Sub Form_Deactivate()
  CallEvent cf_ChildDeActivated
End Sub

Private Sub Form_GotFocus()
  CallEvent cf_ChildGotFocus
End Sub

Private Sub Form_LostFocus()
  CallEvent cf_ChildLostFocus
End Sub

Private Sub Form_Load()
  CallEvent cf_ChildLoaded
End Sub

Private Sub Form_Unload(Cancel As Integer)
  CallEvent cf_ChildUnLoaded
End Sub

Private Sub cmdRaiseClick_Click()
  CallEvent cf_ChildButtonClicked
End Sub

Private Sub CallEvent(ByVal nEvent As EVENT_INDEXES)

  ' check to make sure the pointer we are holding is still valid.
  ' if it is, we use the ResolvePointer function to turn the unreferenced
  ' pointer we are holding into a valid reference to the collection object
  ' and call it's FireEvent method passing the info about which event to raise
  If MValidatePointer.IsPointerValid(m_lpCChildForms) > (-1) Then
    ResolvePointer(m_lpCChildForms).FireEvent nEvent, m_sKey, ObjPtr(Me)
  End If

End Sub
' **************************************************

Private Function ResolvePointer(ByVal lpObj&) As CChildForms
  ' this function takes a dumb numeric pointer and turns it into
  ' a valid object reference.  do not end your project while in
  ' this sub unless you like to crash.
  
  Dim oCF As CChildForms
  
  CopyMemory oCF, lpObj, 4&
  Set ResolvePointer = oCF
  CopyMemory oCF, 0&, 4&

End Function

