VERSION 5.00
Begin VB.MDIForm frmMDIParent 
   BackColor       =   &H8000000C&
   Caption         =   "Raising Events Through A Collection"
   ClientHeight    =   7500
   ClientLeft      =   1530
   ClientTop       =   1830
   ClientWidth     =   9795
   Icon            =   "frmMDIParent.frx":0000
   LinkTopic       =   "MDIForm1"
   Begin VB.PictureBox Picture1 
      Align           =   2  'Align Bottom
      Height          =   915
      Left            =   0
      ScaleHeight     =   57
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   649
      TabIndex        =   0
      Top             =   6585
      Width           =   9795
      Begin VB.TextBox txEventLog 
         Height          =   870
         Left            =   15
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   1
         Top             =   0
         Width           =   9735
      End
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "Options"
      Begin VB.Menu mnuAddNew 
         Caption         =   "Add New Collection Member"
      End
   End
End
Attribute VB_Name = "frmMDIParent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to raise events from objects contained
  ' in a collection or array without creating circular references
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.

  ' dimention our collection object using WithEvents
  Private WithEvents m_oChildForms As CChildForms

Private Sub MDIForm_Load()
  
  ' create an instance of our collection object
  Set m_oChildForms = New CChildForms
  
  Dim i&
  
  ' add some items to the collection by calling the collection's Add method
  For i = 0 To 3
    m_oChildForms.Add
  Next
  
End Sub

Private Sub MDIForm_Unload(Cancel As Integer)
  ' make sure we destroy the collection object
  Set m_oChildForms = Nothing
End Sub
  
Private Sub mnuAddNew_Click()
  ' add another item to the collection
  m_oChildForms.Add
End Sub

' the following are all events raised by the items in
' the collection *through* the collection object
Private Sub m_oChildForms_ChildActivated(ByVal nIndex As Long, ByVal sKey As String)
  ' event raised when a child form is activated
  AddToEventLog "ChildActivated", nIndex, sKey
End Sub

Private Sub m_oChildForms_ChildDeActivated(ByVal nIndex As Long, ByVal sKey As String)
  ' event raised when a child form is deactivated
  AddToEventLog "ChildDeActivated", nIndex, sKey
End Sub

Private Sub m_oChildForms_ChildLoaded(ByVal nIndex As Long, ByVal sKey As String)
  ' event raised when a child form is loaded
  AddToEventLog "ChildLoaded", nIndex, "Key not assigned yet."
End Sub

Private Sub m_oChildForms_ChildUnLoaded(ByVal nIndex As Long, ByVal sKey As String)
  ' event raised when a child form is unloaded
  AddToEventLog "ChildUnLoaded", nIndex, sKey
End Sub

Private Sub m_oChildForms_ChildGotFocus(ByVal nIndex As Long, ByVal sKey As String)
  ' event raised when a child form gets the focus
  AddToEventLog "ChildGotFocus", nIndex, sKey
End Sub

Private Sub m_oChildForms_ChildLostFocus(ByVal nIndex As Long, ByVal sKey As String)
  ' event raised when a child form looses the focus
  AddToEventLog "ChildLostFocus", nIndex, sKey
End Sub

Private Sub m_oChildForms_ChildButtonClicked(ByVal nIndex As Long, ByVal sKey As String)
  ' event raised when the command button is clicked on a child form
  AddToEventLog "ChildButtonClicked", nIndex, sKey
End Sub

' routine used to format and display the event occurrences
Private Sub AddToEventLog(ByVal sEventName$, ByVal nIndex&, ByVal sKey$)
  With txEventLog
    .Text = .Text & sEventName & " event raised from index #" _
                                & CStr(nIndex) & ".  The Key is: " & sKey & vbCrLf
    
    .SelStart = Len(.Text)
  End With
End Sub
